package com.tanpu.fund.entity.generator;

import com.tanpu.common.id.AutoId;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class FundNav {
    
 public static final String TABLE_NAME = "fund_nav";

    /**
     * 
     */
    @AutoId(value = AutoId.IdType.SNOWFLAKE)
    private String id;

    /**
     * 基金id，'HF'开头(后加36进制编码格式,不足8位长度左补零） 例：HF00000001
     */
    private String fundId;

    /**
     * 净值日期
     */
    private Date priceDate;

    /**
     * 单位净值
     */
    private BigDecimal nav;

    /**
     * 考虑分红再投资的单位累计净值
     */
    private BigDecimal cumulativeNav;

    /**
     * 分红不投资的单位累计净值
     */
    private BigDecimal cumulativeNavWithdrawal;

    /**
     * 净值创新高或新低标志；1-创历史新高；2-创历史新低；3-既没有创历史新高也没有创历史新低;-1-其他
     */
    private Integer ishighOrLow;

    /**
     * 距离历史新高的距离，（历史最高累计净值-最新累计净值）*100%/最新累计净值
     */
    private BigDecimal tohighNavRatio;

    /**
     * 
     */
    private String createBy;

    /**
     * 
     */
    private Date createTime;

    /**
     * 
     */
    private String updateBy;

    /**
     * 
     */
    private Date updateTime;

    /**
     * 
     */
    private Integer deleteTag;

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", id=").append(id);
        sb.append(", fundId=").append(fundId);
        sb.append(", priceDate=").append(priceDate);
        sb.append(", nav=").append(nav);
        sb.append(", cumulativeNav=").append(cumulativeNav);
        sb.append(", cumulativeNavWithdrawal=").append(cumulativeNavWithdrawal);
        sb.append(", ishighOrLow=").append(ishighOrLow);
        sb.append(", tohighNavRatio=").append(tohighNavRatio);
        sb.append(", createBy=").append(createBy);
        sb.append(", createTime=").append(createTime);
        sb.append(", updateBy=").append(updateBy);
        sb.append(", updateTime=").append(updateTime);
        sb.append(", deleteTag=").append(deleteTag);
        sb.append("]");
        return sb.toString();
    }

    /**
     * This enum was generated by MyBatis Generator.
     * This enum corresponds to the database table fund_nav
     *
     * @mbg.generated Thu Sep 03 15:06:06 CST 2020
     */
    public enum Column {
        id("id", "id", "VARCHAR", false),
        fundId("fund_id", "fundId", "VARCHAR", false),
        priceDate("price_date", "priceDate", "DATE", false),
        nav("nav", "nav", "DECIMAL", false),
        cumulativeNav("cumulative_nav", "cumulativeNav", "DECIMAL", false),
        cumulativeNavWithdrawal("cumulative_nav_withdrawal", "cumulativeNavWithdrawal", "DECIMAL", false),
        ishighOrLow("ishigh_or_low", "ishighOrLow", "INTEGER", false),
        tohighNavRatio("tohigh_nav_ratio", "tohighNavRatio", "DECIMAL", false),
        createBy("create_by", "createBy", "VARCHAR", false),
        createTime("create_time", "createTime", "TIMESTAMP", false),
        updateBy("update_by", "updateBy", "VARCHAR", false),
        updateTime("update_time", "updateTime", "TIMESTAMP", false),
        deleteTag("delete_tag", "deleteTag", "INTEGER", false);

        private static final String BEGINNING_DELIMITER = "\"";

        private static final String ENDING_DELIMITER = "\"";

        private final String column;

        private final boolean isColumnNameDelimited;

        private final String javaProperty;

        private final String jdbcType;

        public String value() {
            return this.column;
        }

        public String getValue() {
            return this.column;
        }

        public String getJavaProperty() {
            return this.javaProperty;
        }

        public String getJdbcType() {
            return this.jdbcType;
        }

        Column(String column, String javaProperty, String jdbcType, boolean isColumnNameDelimited) {
            this.column = column;
            this.javaProperty = javaProperty;
            this.jdbcType = jdbcType;
            this.isColumnNameDelimited = isColumnNameDelimited;
        }

        public String desc() {
            return this.getEscapedColumnName() + " DESC";
        }

        public String asc() {
            return this.getEscapedColumnName() + " ASC";
        }

        public static Column[] excludes(Column ... excludes) {
            ArrayList<Column> columns = new ArrayList<>(Arrays.asList(Column.values()));
            if (excludes != null && excludes.length > 0) {
                columns.removeAll(new ArrayList<>(Arrays.asList(excludes)));
            }
            return columns.toArray(new Column[]{});
        }

        public static Column[] all() {
            return Column.values();
        }

        public String getEscapedColumnName() {
            if (this.isColumnNameDelimited) {
                return new StringBuilder().append(BEGINNING_DELIMITER).append(this.column).append(ENDING_DELIMITER).toString();
            } else {
                return this.column;
            }
        }

        public String getAliasedEscapedColumnName() {
            return this.getEscapedColumnName();
        }
    }
}